# -*- coding: utf-8 -*-
from setuphelpers import *

""" 
FoxitPDFReader1212_L10N_Setup_Prom.exe
FoxitPDFReader1212_L10N_Setup.exe
FoxitPDFReader1212_enu_Setup_Clean.exe
FoxitPDFReader1212_enu_Setup_Prom.exe
FoxitPDFReader1212_L10N_Setup.msi
FoxitPDFReader1212_enu_Setup.msi

OK:
https://cdn01.foxitsoftware.com/product/reader/desktop/win/12.1.2/FoxitPDFReader1212_L10N_Setup.msi
NOK:
https://cdn78.foxitsoftware.com/product/reader/desktop/win/12.1.2/FoxitPDFReader1212_L10N_Setup.msi


"""


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()

    url = "https://www.foxit.com/pdf-reader/version-history.php"
    download_url = "https://www.foxit.com/downloads/latest.php?product=Foxit-Reader&platform=Windows&package_type=exe&language=French"  # Do not use the URL: "language=English" (it will not download language packs)

    # Getting latest version information from download url
    requests_result = requests.head(download_url, proxies=proxies, allow_redirects=True, verify=False)
    download_url = requests_result.url
    latest_bin = download_url.split("/")[-1]
    version = requests_result.url.split("/")[-2]

    # Deleting binaries
    remove_outdated_binaries("*")

    # Downloading latest binaries
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies,verify_cert=makepath(systemdrive, programfiles32, "wapt", "lib", "site-packages", "certifi", "cacert.pem")
        )
    else:
        print("Binary is present: %s" % latest_bin)

    # Checking version from file
    if get_os_name() == "Windows" and "windows" in control.target_os.lower():
        version_from_file = get_version_from_binary(latest_bin)
        if Version(version_from_file, 4) == Version(version, 4):
            print("INFO: Binary file version corresponds to online version")
        elif Version(version_from_file, 3) == Version(version, 3):
            print("INFO: Binary file version is superior, changing version to binary version (from %s to %s)" % (version, version_from_file))
            version = version_from_file
        else:
            error("ERROR: Binary file version do NOT corresponds to online version")

    # Changing version of the package
    if Version(version, 4) > Version(control.get_software_version(), 4):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating update-package-sources
    return package_updated
